您的位置:首页 > 其它

HDU 5135 Little Zu Chongzhi's Triangles(贪心)

2015-01-16 15:44 337 查看


Little Zu Chongzhi's Triangles

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 512000/512000 K (Java/Others)

Total Submission(s): 304    Accepted Submission(s): 180


Problem Description

Zu Chongzhi (429–500) was a prominent Chinese mathematician and astronomer during the Liu Song and Southern Qi Dynasties. Zu calculated the value ofπ to the precision of six decimal places and for a thousand years thereafter no subsequent mathematician computed
a value this precise. Zu calculated one year as 365.24281481 days, which is very close to 365.24219878 days as we know today. He also worked on deducing the formula for the volume of a sphere. 

It is said in some legend story books that when Zu was a little boy, he liked mathematical games. One day, his father gave him some wood sticks as toys. Zu Chongzhi found a interesting problem using them. He wanted to make some triangles by those sticks, and
he wanted the total area of all triangles he made to be as large as possible. The rules were :

1) A triangle could only consist of 3 sticks.

2) A triangle's vertexes must be end points of sticks. A triangle's vertex couldn't be in the middle of a stick.

3) Zu didn't have to use all sticks.

Unfortunately, Zu didn't solve that problem because it was an algorithm problem rather than a mathematical problem. You can't solve that problem without a computer if there are too many sticks. So please bring your computer and go back to Zu's time to help
him so that maybe you can change the history.

 

Input

There are no more than 10 test cases. For each case:

The first line is an integer N(3 <= N<= 12), indicating the number of sticks Zu Chongzhi had got. The second line contains N integers, meaning the length of N sticks. The length of a stick is no more than 100. The input ends with N = 0.

 

Output

For each test case, output the maximum total area of triangles Zu could make. Round the result to 2 digits after decimal point. If Zu couldn't make any triangle, print 0.00 .

 

Sample Input

3
1 1 20
7
3 4 5 3 4 5 90
0

 

Sample Output

0.00
13.64

 

Source

2014ACM/ICPC亚洲区广州站-重现赛(感谢华工和北大)

 

题目大意:

给一些线段的长度,要求将他们组合成一些三角形,使得总面积最大。

解题思路:

根据海伦公式,可以贪心解。即变长越大,三角形面积越大。

所以,将所有边排序后,从大到小,如果最大的三条边可以组成三角形,则采用这种组合;

若无法组成三角形,即第二大和第三大的边之和不大于第一大的边(因已经排序,其他限制不用考虑),则丢弃第一大的边,因为之后的边任意组合也不可能与最大边组成三角形。

参考代码:

#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cmath>
using namespace std;

const int MAXN = 20;
double ans;
int n, l[MAXN];

void init() {
ans = 0;
}

void input() {
for (int i = 0; i < n; i++) {
scanf("%d", &l[i]);
}
}

double calcArea(int i) {
double a = l[i], b = l[i-1], c = l[i-2];
double p = (a + b + c) / 2.0;
return sqrt(p * (p - a) * (p - b) * (p - c));
}

void solve() {
sort(l, l+n);
int i = n - 1;
while (i >= 2) {
if (l[i] <= l[i-1] + l[i-2]) {
ans += calcArea(i);
i = i - 3;
} else {
i = i - 1;
}
}
printf("%.2lf\n", ans);
}

int main() {
while (~scanf("%d", &n) && n) {
init();
input();
solve();
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签:  acm-icpc ACM2014 广州